Bug 1297347 - Review Request: java-comment-preprocessor
Review Request: java-comment-preprocessor
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Pavel Raiskup
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-01-11 05:03 EST by Pavel Kajaba
Modified: 2016-06-29 08:56 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-06-29 08:56:55 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
praiskup: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Pavel Kajaba 2016-01-11 05:03:24 EST
Spec URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor.spec
SRPM URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor-6.0.1-1.fc23.src.rpm
Description: The Multi-Pass Java Preprocessor
Comment 1 Pavel Raiskup 2016-01-11 10:09:19 EST
My major concern to ask for edit is to fix the packaging of license file which
is available in tarball.  See also the one trailing whitespace and
mixed-use-of-space-and-tabs catched by rpmlint.

Shortened fedora-review output:

===== MUST items =====

Generic:
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[!]: License file installed when any subpackage combination is installed.
[!]: Package complies to the Packaging Guidelines

===== SHOULD items =====

Generic:
[?]: Package functions as described.

praiskup: I'll test with 'postgresql-jdbc' build once Pavel gives me a patch.

[!]: %check is present and all tests pass.

praiskup: there seem to be testsuite within the pom.xml, if that is truth -
could we nable it?

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


attachments:
java-comment-preprocessor.src:13: W: mixed-use-of-spaces-and-tabs (spaces: line 13, tab: line 1)
3 packages and 0 specfiles checked; 0 errors, 7 warnings.
Comment 2 Pavel Kajaba 2016-01-12 07:33:23 EST
Spec URL: https://fedorapeople.org/cgit/pkajaba/public_git/java-comment-preprocessor.git/plain/java-comment-preprocessor.spec?id=1ad7813cba3c355822e0f43cd1019f7a327463ba
SRPM URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor-6.0.1-1.fc23.src.rpm

- Licence should be added.

- Testsuite is enabled.

- trailing whitespace fixed

private branch of postgresql-jdbc where are changes applied is 'private-pkajaba-postgresql-jdbc-1207'

In case you want to try to build it download another dependency https://pkajaba.fedorapeople.org/postgresql-jdbc-parent-poms-1.0.3-1.fc23.noarch.rpm
Comment 3 Pavel Raiskup 2016-01-12 10:25:04 EST
Thanks for the package.

There is no major issue, I guess.  Nits for the next reviews -- you should
udpdate %changelog during review, the jpackage-utils should not be in
'Requires:'.  Otherwise fine.  Please remove the jpackage-utils require.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Packages have proper BuildRequires/Requires on jpackage-utils
  Note: Maven packages do not need to (Build)Require jpackage-utils. It is
  pulled in by maven-local
  See: https://fedoraproject.org/wiki/Packaging:Java


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
     Note: Can't find any BUILD directory (--prebuilt option?)
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in java-
     comment-preprocessor-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
praiskup: done different way?
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: java-comment-preprocessor-6.0.1-1.fc24.noarch.rpm
          java-comment-preprocessor-javadoc-6.0.1-1.fc24.noarch.rpm
          java-comment-preprocessor-6.0.1-1.fc24.src.rpm
java-comment-preprocessor.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
java-comment-preprocessor.noarch: W: no-version-in-last-changelog
java-comment-preprocessor-javadoc.noarch: W: no-version-in-last-changelog
java-comment-preprocessor.src: W: spelling-error %description -l en_US multi -> mulch, mufti
java-comment-preprocessor.src: W: no-version-in-last-changelog
3 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
java-comment-preprocessor-javadoc.noarch: W: no-version-in-last-changelog
java-comment-preprocessor.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
java-comment-preprocessor.noarch: W: no-version-in-last-changelog
2 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
java-comment-preprocessor-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

java-comment-preprocessor (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils
    mvn(commons-io:commons-io)
    mvn(org.apache.ant:ant)
    mvn(org.apache.commons:commons-lang3)
    mvn(org.apache.maven.shared:file-management)
    mvn(org.apache.maven:maven-core)
    mvn(org.apache.maven:maven-plugin-api)



Provides
--------
java-comment-preprocessor-javadoc:
    java-comment-preprocessor-javadoc

java-comment-preprocessor:
    java-comment-preprocessor
    mvn(com.igormaznitsa:jcp)
    mvn(com.igormaznitsa:jcp:pom:)



Source checksums
----------------
https://github.com/raydac/java-comment-preprocessor/archive/6.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : a06153bc6ff6e87d69e2984b1bdaa7080ef55639dc6bf90b1d73eed36cf7b07e
  CHECKSUM(SHA256) upstream package : a06153bc6ff6e87d69e2984b1bdaa7080ef55639dc6bf90b1d73eed36cf7b07e


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1297347 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 4 gil cattaneo 2016-04-15 08:43:02 EDT
The spec file is full of useless and dangerous things:
- useless:

already added by maven-local. please remove
BuildRequires:	java-devel >= 1:1.8
Requires:	java-headless >= 1:1.8


NO more necessary. please remove
Group:		Documentation

%check (is NOT necessary. please remove)

please, use
%files javadoc -f .mfiles-javadoc
%license texts/LICENSE-2.0.txt

instead of

%files javadoc
%license texts/LICENSE-2.0.txt
%doc %{_javadocdir}/%{name} (is NOT necessary. please remove)

This:
%setup -c -q
mv -f %{name}-%{version}/* .

for me does not make sense, at least I can not explain it

- dangerous:
BuildRequires:	maven-shade-plugin
is not safe introduce copy of system libraries into this or other artifact
for example if one of these have a "security problems". the
maintainer work would be compromised and the problem remain if this package is not rebuilt every time a dependency is updated
Comment 5 Pavel Kajaba 2016-04-15 13:33:13 EDT
Thanks for additional review! I have removed redundant dependencies, dangerous dependencies and also removed useless lines.

Spec URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor.spec
SRPM URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor-6.0.1-2.fc23.src.rpm

There is diff of changes: 
https://fedorapeople.org/cgit/pkajaba/public_git/java-comment-preprocessor.git/commit/?id=30394edc5fbcead1da4b79cd84ae74e50d0b1204
Comment 6 gil cattaneo 2016-04-15 13:59:59 EDT
(In reply to Pavel Kajaba from comment #5)
> Thanks for additional review! I have removed redundant dependencies,
> dangerous dependencies and also removed useless lines.
> 
> Spec URL: https://pkajaba.fedorapeople.org/java-comment-preprocessor.spec
> SRPM URL:
> https://pkajaba.fedorapeople.org/java-comment-preprocessor-6.0.1-2.fc23.src.
> rpm
> 
> There is diff of changes: 
> https://fedorapeople.org/cgit/pkajaba/public_git/java-comment-preprocessor.
> git/commit/?id=30394edc5fbcead1da4b79cd84ae74e50d0b1204
Thanks for your work
See https://fedorapeople.org/cgit/pkajaba/public_git/java-comment-preprocessor.git/tree/java-comment-preprocessor.spec?id=30394edc5fbcead1da4b79cd84ae74e50d0b1204#n21
please remove unneeded Requires
Comment 7 gil cattaneo 2016-04-15 14:00:50 EDT
... and also BuildRequires:	jpackage-utils
Comment 8 Pavel Kajaba 2016-04-15 17:13:56 EDT
https://fedorapeople.org/cgit/pkajaba/public_git/java-comment-preprocessor.git/tree/java-comment-preprocessor.spec

Here is the most current version.

Which ones are unneded now?
Comment 9 gil cattaneo 2016-04-15 18:07:19 EDT
Both, because using as BRs maven-local(*) is already available
as Rs (are automatically generated by JP-Ts)
Requires:      jpackage-utils
Requires:      java-headless >= 1:1.8
and BRs
BuildRequires: java-devel >= 1:1.8
BuildRequires: jpackage-utils (*)

(*)  sub package of javapackages-tools
(**) alias of javapackages-tools
Sorry for the noise
Comment 10 Pavel Kajaba 2016-04-16 05:08:47 EDT
It's ok :)

But have you checked that git what I send?

It's not there anymore :)
Comment 11 Fedora Update System 2016-06-20 01:26:32 EDT
java-comment-preprocessor-6.0.1-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-37464bcf2d
Comment 12 Fedora Update System 2016-06-20 16:54:21 EDT
java-comment-preprocessor-6.0.1-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-37464bcf2d
Comment 13 Fedora Update System 2016-06-29 08:56:52 EDT
java-comment-preprocessor-6.0.1-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.